function [bbout, valid, part_parent] = detection_spot(part_parent,root, nodepa, valid, npart, scalepre, imgin, bb, pos_center,window_sz,cell_size,response)
%DETECTION_TREE Summary of this function goes here
%   Detailed explanation goes here
    
kernel.sigma = 0.5;					%gaussian kernel bandwidth

width    = cell(1, npart);
height   = cell(1, npart);
Ix1      = cell(1, npart); 
Iy1      = cell(1, npart);
part_cen = cell(1, npart);
map      = cell(1, npart);
loc_temp = cell(1, npart);
loc      = cell(1, npart);
inconf_map = cell(1, npart); 
confidence = cell(1, npart);
conf_part  = cell(1, npart);
part_partemp = zeros(npart, 2);
time1 = 0;  %to calculate FPS


for i=1:npart

    % pixel size of object  
    height{i}=bb{i}(4)-bb{i}(2)+1;  % bb[y1 x1 y2 x2]
    width{i}=bb{i}(3)-bb{i}(1)+1;
   


end

traff1=0.001;
traff2=0;
%feat = RawFeat(imgin, sbin);

for ii=1:npart

    
    
    confidence{ii}=1 ./ (1 + exp(-response{ii}));
    confidence{ii}=circshift(confidence{ii}, floor(size(confidence{ii})/2));
    
     conf_map = zeros(size(imgin, 1), size(imgin, 2));   
     
     cor_koord{ii}=pos_center{ii}-floor(window_sz{ii}/(2*cell_size)); 
     
     for i=1:size(confidence{ii},1)
         for j=1:size(confidence{ii},2)
               if i+cor_koord{ii}(1)-1>0 && j+cor_koord{ii}(2)-1>0 && i+cor_koord{ii}(1)< size(conf_map,1) && j+cor_koord{ii}(2)< size(conf_map,2)
               conf_map(i+cor_koord{ii}(1)-1, j+cor_koord{ii}(2)-1)= confidence{ii}(i,j);
               end
         end
     end
     
    inconf_map{ii}= conf_map;
    
    [inconf_map{ii}, Ix1{ii}, Iy1{ii}] = dt(inconf_map{ii},traff1,traff2,traff1,traff2);

    part_cen{ii}=[0.1 0.1];
    part_partemp(ii,:)=part_parent{ii};
end 

% Get path from node to root
part_parent{root}=[0 0];
part_partemp(root,:)=[0 0];
part_cen{root}=[0 0];
for i=1:length(nodepa)
    n=length(nodepa{i});
    temp = part_partemp(nodepa{i},:);
    for j=n-1:-1:1
        if part_cen{nodepa{i}(j)}(1)~=0 && part_cen{nodepa{i}(j)}(2)~=0 
           part_cen{nodepa{i}(j)}=sum(temp(j:n-1,:),1);
        end
    end
    
end

% Score map
suminconf_map=zeros(size(inconf_map{i},1),size(inconf_map{i},2));
for i=1:npart
    part_cen{i}=round(part_cen{i});
    map{i}=zeros(size(suminconf_map,1),size(suminconf_map,2));
    if part_cen{i}(1)<=0 && part_cen{i}(2)<=0
       map{i}(1:size(map{i},1)-abs(part_cen{i}(1)),1:size(map{i},2)-abs(part_cen{i}(2)))= inconf_map{i}(abs(part_cen{i}(1))+1:size(map{i},1),abs(part_cen{i}(2))+1:size(map{i},2));
    elseif part_cen{i}(1)<=0 && part_cen{i}(2)>0
       map{i}(1:size(map{i},1)-abs(part_cen{i}(1)),part_cen{i}(2)+1:size(map{i},2))= inconf_map{i}(abs(part_cen{i}(1))+1:size(map{i},1),1:size(map{i},2)-part_cen{i}(2));
    elseif part_cen{i}(1)>0 && part_cen{i}(2)<=0
       map{i}(part_cen{i}(1)+1:size(map{i},1),1:size(map{i},2)-abs(part_cen{i}(2)))= inconf_map{i}(1:size(map{i},1)-part_cen{i}(1),abs(part_cen{i}(2))+1:size(map{i},2)); 
    else
       map{i}(part_cen{i}(1)+1:size(map{i},1),part_cen{i}(2)+1:size(map{i},2))= inconf_map{i}(1:size(map{i},1)-part_cen{i}(1),1:size(map{i},2)-part_cen{i}(2)); 
    end
    suminconf_map=suminconf_map+map{i};
    
end
inconfi1 = max(suminconf_map(:));   

[x1,y1]=find(suminconf_map==inconfi1);



for i=1:npart     
    scaleout{i}=scalepre{i};
    loc_temp{i}=round([mean(x1) mean(y1)]-round(part_cen{i}*scalepre{i}));
    if loc_temp{i}(1)<1 || loc_temp{i}(1)>size(Iy1{i},1) || loc_temp{i}(2)<1 || loc_temp{i}(2)>size(Iy1{i},2)
       loc_temp{i}(1)=round(min(size(Iy1{i},1),max(1,loc_temp{i}(1))));
       loc_temp{i}(2)=round(min(size(Iy1{i},2),max(1,loc_temp{i}(2))));
    end 
    loc{i}=double([Iy1{i}(loc_temp{i}(1),loc_temp{i}(2)),Ix1{i}(loc_temp{i}(1),loc_temp{i}(2))]);
        
    
    conf_temp=confidence{i}(:);
   
     conf_part{i}= max(conf_temp);
    
     confidence_part(i) = max(response{i}(:));
    
 bbout{i}=floor([loc{i}(2) - width{i}/2, loc{i}(1) - height{i}/2,loc{i}(2) + width{i}/2, loc{i}(1) + height{i}/2]);



    if conf_part{i}>0.554 %|| frame<=num 

        valid(i)=1;
     else
        valid(i)=0;
        
    end
end 


for i=1:npart    
    if valid(i) %|| frame<num
        for j=1:length(nodepa)
           ind=find(i==nodepa{j});
           if ind==length(nodepa{j})
               parent=nodepa{j}(ind);
           elseif isempty(ind)==0 
               parent=nodepa{j}(ind+1);
           end
        end
        
        
        posvector{i}=loc{parent}-loc{i};
         Cvet=1;

         loss=confidence_part(i)+traff1*sum((posvector{i}-part_parent{i}).^2);
         loss_descen=4*traff1^2*sum((posvector{i}-part_parent{i}).^2);
         stepsize=loss./ (loss_descen + (1 ./ (2 .* Cvet)));
        part_parent{i}=(part_parent{i}/scaleout{i}+0.05*posvector{i})/1.05;
    end
end
time1 = time1 + toc();
